; 
    include ranrottest2.asm
    include ranrottestsse.asm

    WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

    topx MACRO wwd
      invoke GetSystemMetrics, SM_CXSCREEN
      shr   eax, 1
      mov   edx, wwd
      shr   edx, 1
      sub   eax, edx
      EXITM <eax>
    ENDM
    topy MACRO wht
      invoke GetSystemMetrics, SM_CYSCREEN
      shr   eax, 1
      mov   edx, wht
      shr   edx, 1
      sub   eax, edx
      EXITM <eax>
    ENDM

    update_title MACRO quotedtext
      mov   eax, cat$(ADDR wTitle,chr$(quotedtext))
      mov   eax, cat$(ADDR wTitle,ustr$(rect.right))
      mov   eax, cat$(ADDR wTitle,chr$("x"))
      mov   eax, cat$(ADDR wTitle,ustr$(rect.bottom))
      invoke SetWindowText, hWnd, ADDR wTitle
    ENDM

    .data
        selection     dd 0
        update_flag   dd 0
        
        tmp_xmm		DD	0,0,0,0
    .code

start:

; 

    call WRandomInit	; Init to something    
    
    call main
    invoke ExitProcess, eax

; 

; 
; This proc is an asm version of the single-threaded CRT
; rand function, based on the rand.c source that was
; distributed with the PSDK:
;
; return(((holdrand=holdrand*214013L+2531011L)>>16)&0x7fff);
;
; It returns a random 32-bit integer in the interval 0
; to base - 1, where base must be in the range 1 to
; RAND_MAX (= 7fffh).
; 

RAND_SEED equ 12345   ; Arbitrary non-zero value < 7fffh

.data
    ALIGN 4
    crt_rand_asm_seed dd RAND_SEED
    
.code
ALIGN 4
crt_rand_asm proc base:DWORD
    mov   eax, crt_rand_asm_seed
    mov   ecx, 214013
    mul   ecx
    add   eax, 2531011
    mov   crt_rand_asm_seed, eax
    shr   eax, 16
    and   eax, 7fffh
    xor   edx, edx 
    div   base
    movzx eax, dx
    ret
crt_rand_asm endp

; 

main proc
    LOCAL hInstance   :DWORD
    LOCAL hWnd        :DWORD
    LOCAL hIcon       ;DWORD
    LOCAL hCursor     :DWORD
    LOCAL wwd         :DWORD
    LOCAL wht         :DWORD
    LOCAL wtx         :DWORD
    LOCAL wty         :DWORD
    LOCAL hDC         :DWORD
    LOCAL msg         :MSG
    LOCAL rect        :RECT
    LOCAL wcx         :WNDCLASSEX
    LOCAL wTitle[100] :BYTE

    zero1 wTitle                ; Necessary for cat$ macro.

    mov hInstance, FUNC(GetModuleHandle,NULL)
    mov hIcon, FUNC(LoadIcon, NULL, IDI_APPLICATION)
    mov hCursor, FUNC(LoadCursor, NULL, IDC_ARROW)
    szText szClassName,"vrandtest_class"
    szText szDisplayName,"vrandtest"
    
    mov   wcx.cbSize, SIZEOF WNDCLASSEX
    mov   wcx.style, CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
    mov   wcx.lpfnWndProc, OFFSET WndProc
    mov   wcx.cbClsExtra, NULL
    mov   wcx.cbWndExtra, NULL
    mov   wcx.hInstance, 400000h
    invoke GetStockObject, WHITE_BRUSH
    mov   wcx.hbrBackground, eax
    mov   wcx.lpszMenuName, NULL
    mov   wcx.lpszClassName, OFFSET szClassName
    m2m   wcx.hIcon, hIcon
    m2m   wcx.hCursor, hCursor
    m2m   wcx.hIconSm, hIcon

    invoke RegisterClassEx, ADDR wcx

    mov   wwd, 600
    mov   wht, 400
    mov   wtx, topx(wwd)
    mov   wty, topy(wht)

    invoke CreateWindowEx,  WS_EX_OVERLAPPEDWINDOW,
                            ADDR szClassName,
                            ADDR szDisplayName,
                            WS_OVERLAPPEDWINDOW,
                            wtx, wty, wwd, wht,
                            NULL, NULL,
                            hInstance, NULL
    mov   hWnd, eax

    invoke LoadMenu, hInstance, 600
    invoke SetMenu, hWnd, eax

    invoke ShowWindow, hWnd, SW_SHOWNORMAL
    ;invoke UpdateWindow, hWnd

    invoke GetDC, hWnd
    mov   hDC, eax

  StartLoop:
    invoke PeekMessage, ADDR msg, NULL, 0, 0, PM_REMOVE
    cmp   eax, 0
    je    @F
    cmp   msg.message, WM_QUIT
    je    ExitLoop
    invoke TranslateMessage, ADDR msg
    invoke DispatchMessage, ADDR msg
  @@:
    invoke GetClientRect, hWnd, ADDR rect

    .IF update_flag != 0
        mov   update_flag, 0  
        zero1 wTitle              ; To clear current contents.
        invoke FillRect, hDC, ADDR rect, wcx.hbrBackground
        .IF selection == 1000
          update_title "vrandrottest: M_WBRandom "
        .ELSEIF selection == 1001
          update_title "vrandrottest: M_WBRandomL  "
        .ELSEIF selection == 1002
          update_title "vrandrottest: M_WBRandom2  "
        .ELSEIF selection == 1003
          update_title "vrandrottest: M_WBRandom2L  "
        .ELSEIF selection == 1004
          update_title "vrandrottest: M_WBRandomSSE  "
        .ELSEIF selection == 1005
          update_title "vrandrottest: M_WBRandomSSEL  "
        .ELSEIF selection == 1006
          update_title "vrandrottest: crt_rand_asm "
        .ELSEIF selection == 1007
          update_title "vrandrottest: nrandom  "
        .ENDIF
    .ENDIF
    
    .IF selection == 1000
      push  ebx
      push  ecx
      M_WBRandom
      pop   ecx
      pop   ebx
      xor   edx, edx
      div   rect.right
      mov   ebx, edx
      push  ebx
      push  ecx
      M_WBRandom
      pop   ecx
      pop   ebx
      xor   edx, edx
      div   rect.bottom
      mov   esi, edx
    .ELSEIF selection == 1001
      push  ebx
      push  ecx
      M_WBRandomL
      pop   ecx
      pop   ebx
      xor   edx, edx
      div   rect.right
      mov   ebx, edx
      push  ebx
      push  ecx
      M_WBRandomL
      pop   ecx
      pop   ebx
      xor   edx, edx
      div   rect.bottom
      mov   esi, edx
    .ELSEIF selection == 1002
      push  ebx
      push  ecx
      M_WBRandom2
      pop   ecx
      pop   ebx
      xor   edx, edx
      div   rect.right
      mov   ebx, edx
      push  ebx
      push  ecx
      M_WBRandom2
      pop   ecx
      pop   ebx
      xor   edx, edx
      div   rect.bottom
      mov   esi, edx
    .ELSEIF selection == 1003
      push  ebx
      push  ecx
      M_WBRandom2L
      pop   ecx
      pop   ebx
      xor   edx, edx
      div   rect.right
      mov   ebx, edx
      push  ebx
      push  ecx
      M_WBRandom2L
      pop   ecx
      pop   ebx
      xor   edx, edx
      div   rect.bottom
      mov   esi, edx
    .ELSEIF selection == 1004
      call WRandomInitSSE
      push  ebx
      push  ecx
      M_WBRandomSSE
      pop   ecx
      pop   ebx
      movapd tmp_xmm, xmm0
      mov eax, tmp_xmm
      xor   edx, edx
      div   rect.right
      mov   ebx, edx
;      push  ebx
;      push  ecx
;      M_WBRandomSSE
;      pop   ecx
;      pop   ebx
			mov eax, tmp_xmm[4]
      xor   edx, edx
      div   rect.bottom
      mov   esi, edx
    .ELSEIF selection == 1005
      call WRandomInitSSE
      push  ebx
      push  ecx
      M_WBRandomSSEL
      pop   ecx
      pop   ebx
      movapd tmp_xmm, xmm0
      xor   edx, edx
      mov eax, tmp_xmm
      div   rect.right
      mov   ebx, edx
;      push  ebx
;      push  ecx
;      M_WBRandomSSEL
;      pop   ecx
;      pop   ebx
			mov eax, tmp_xmm[4]
      xor   edx, edx
      div   rect.bottom
      mov   esi, edx
    .ELSEIF selection == 1006
      invoke crt_rand_asm, rect.right
      mov   ebx, eax
      invoke crt_rand_asm, rect.bottom
      mov   esi, eax
    .ELSEIF selection == 1007
      invoke nrandom, rect.right
      mov   ebx, eax
      invoke nrandom, rect.bottom
      mov   esi, eax 
    .ENDIF

    invoke SetPixel, hDC, ebx, esi, 0

    jmp   StartLoop

  ExitLoop:
    invoke ReleaseDC, hWnd, hDC
    mov   eax, msg.wParam
    ret
main endp

; 

WndProc proc  hWin  :DWORD,
              uMsg  :DWORD,
              wParam:DWORD,
              lParam:DWORD

    .IF uMsg == WM_COMMAND
      mov   eax, wParam
      mov   selection, eax
      inc   update_flag
    .ELSEIF uMsg == WM_SIZE
      inc   update_flag
    .ELSEIF uMsg == WM_DESTROY
      invoke PostQuitMessage, NULL
      xor   eax, eax
      ret
    .ENDIF
    invoke DefWindowProc, hWin, uMsg, wParam, lParam
    ret
WndProc endp

; 
end start
